﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace ornek1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            caylar.Items.Add("Ocak");
            caylar.Items.Add("Şubat");
            caylar.Items.Add("Mart");
            caylar.Items.Add("Nisan");
            caylar.Items.Add("Mayıs");
            caylar.Items.Add("Haziran");
            caylar.Items.Add("Temmuz");
            caylar.Items.Add("Ağustos");
            caylar.Items.Add("Eylül");
            caylar.Items.Add("Ekim");
            caylar.Items.Add("Kasım");
            caylar.Items.Add("Aralık");
            caylar.Text = "Seçiniz";

        }

        ListBox lsinir = new ListBox();
        ListBox loran = new ListBox();


        private void boranlar_Click(object sender, EventArgs e)
        {
            foranlar frm = new foranlar(lsinir,loran);
            frm.ShowDialog();
            guncelle();
        }

        private void bekle_Click(object sender, EventArgs e)
        {
            int secilen = caylar.SelectedIndex;
            double maas;
            bool k = Double.TryParse(tbrutmaas.Text, out maas);
            int satirsay=lay.Items.Count;

            if (k && secilen > -1)
            {
                lay.Items.Add(caylar.Items[secilen]);
                lbrutmaas.Items.Add(maas);

                double ilkmatrah = 0;
                if (satirsay > 0)
                    ilkmatrah =(double)lsonmatrah.Items[satirsay - 1];
                lilkmatrah.Items.Add(ilkmatrah);
                lvergi.Items.Add(0);
                lnetmaas.Items.Add(0);
                lsonmatrah.Items.Add((maas + ilkmatrah));
                tbrutmaas.Clear();
                guncelle();
                
            }


        }

        private void guncelle()
        {
            for (int index = 0; index < lay.Items.Count; index++)
            {
                double ilkmatrah =(double)lilkmatrah.Items[index];
                double maas = (double)lbrutmaas.Items[index];

                int[] indisler = indisbul(ilkmatrah, maas);

                double toplamvergi = 0;
                for (int x = indisler[0]; x <= indisler[1]; x++)
                {
                    double vergioran = (double)loran.Items[x]*0.01;
                    double fark;
                    if ((double)lsinir.Items[x] <= (ilkmatrah + maas))
                        fark = (double)lsinir.Items[x] - ilkmatrah;
                    else
                        fark = maas;
                    toplamvergi += fark * vergioran;
                    maas -= fark;
                    ilkmatrah += fark;
                }
                lvergi.Items[index] = toplamvergi;
                lnetmaas.Items[index] = (double)lbrutmaas.Items[index] - toplamvergi;
            }
        }


        private int[] indisbul(double ilkmatrah, double maas)
        {
            int[] indisler = {-1,-1};

            for (int i = 0; i < lsinir.Items.Count; i++)
            {
                // ilkindis
                if (indisler[0]==-1 && ilkmatrah <= (double)lsinir.Items[i])
                    indisler[0] = i;

                // sonindis
                if (indisler[1] == -1 && (ilkmatrah+maas) <= (double)lsinir.Items[i])
                    indisler[1] = i;


            }

                return indisler;        
        }


        private void barsivle_Click(object sender, EventArgs e)
        {

            string veri = "";

            for (int index = 0; index < lay.Items.Count; index++)
                veri += lay.Items[index] + ";" + lilkmatrah.Items[index] + ";" + lbrutmaas.Items[index] +
                    ";" + lvergi.Items[index] + ";" + lnetmaas.Items[index] + ";" + lsonmatrah.Items[index] + "\n";

            if (veri.Length > 0)
            {
                try
                {
                    File.WriteAllText("arsiv.txt",veri);
                    MessageBox.Show("Dosyaya yazım başarılı!");
                }
                catch {
                    MessageBox.Show("Dosyaya yazılamadı!");
                }

            
            }

            

        }
    }
}
