﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace ornek1
{
    public partial class foranlar : Form
    {
        ListBox lsinir, loran;
        public foranlar(ListBox l1, ListBox l2)
        {
            InitializeComponent();
            radioButton1.Checked = true;
            lsinir = l1;
            loran = l2;

            for (int index = 0; index < lsinir.Items.Count; index++)
            {
                lsinirdeger.Items.Add(lsinir.Items[index]);
                lvergiorani.Items.Add(loran.Items[index]);
            }

        }

        private void bislem_Click(object sender, EventArgs e)
        {
            if (radioButton1.Checked)
                ekle();
            else
                if (radioButton2.Checked)
                    getir();
                else
                    if (radioButton3.Checked)
                        guncelle();
                    else
                        if (radioButton4.Checked)
                            oku();
                        else
                            yaz();



        }

        private void yaz()
        {
            string veri = "";

            for (int satir = 0; satir < lsinirdeger.Items.Count; satir++)
                veri += lsinirdeger.Items[satir] + ";" + lvergiorani.Items[satir] + "\n";

            if (veri.Length > 0)
            {
                try
                {
                    File.WriteAllText("oranlar.txt", veri);
                    MessageBox.Show("Dosya yazım işlemi başarılı!");
                }
                catch {
                    MessageBox.Show("Dosya yazılamadı!");
                }
            
            }

        }

        private void oku()
        {
            lsinirdeger.Items.Clear();
            lvergiorani.Items.Clear();

            try
            {
                char[] ch = {';'};
                string[] veriler = File.ReadAllLines("oranlar.txt");

                for (int satir = 0; satir < veriler.Length; satir++)
                {
                    string[] parcalar = veriler[satir].Split(ch);
                    if (parcalar.Length == 2)
                    {
                        double sinir, oran;
                        bool k1 = Double.TryParse(parcalar[0], out sinir);
                        bool k2 = Double.TryParse(parcalar[1], out oran);

                        if (k1 && k2)
                        {
                            lsinirdeger.Items.Add(sinir);
                            lvergiorani.Items.Add(oran);
                        }

                    }
                }



            }
            catch {

                MessageBox.Show("Dosya Okunamadı!");
            }
        
         
        }

        private void guncelle()
        {
            double sinir, oran;
            int secilen = lsinirdeger.SelectedIndex;
            bool k1 = Double.TryParse(tsinirdeger.Text, out sinir);
            bool k2 = Double.TryParse(tvergiorani.Text, out oran);

            if (k1 && k2 && secilen>-1)
            { 
                // TODO: degisecek bilginin diger bilgilerle olan iliskisinin arastirilmasi
                // secilen-1 ile secilen+1 degerleri arasinda olmali
                lsinirdeger.Items[secilen] = sinir;
                lvergiorani.Items[secilen] = oran;
                tsinirdeger.Clear();
                tvergiorani.Clear();
            }
            
        
        }

        private void getir()
        {
            int secilen = lsinirdeger.SelectedIndex;

            if (secilen > -1)
            {
                tsinirdeger.Text = lsinirdeger.Items[secilen].ToString();
                tvergiorani.Text = lvergiorani.Items[secilen].ToString();
            }
        
        }

        private void ekle()
        {

            double sinir, oran;
            bool k1 = Double.TryParse(tsinirdeger.Text, out sinir);
            bool k2 = Double.TryParse(tvergiorani.Text, out oran);

           
            if (k1 && k2)
            {
                // listedeki son elemani al, girilen oran ve sinir degeri daha buyuk mu kontrol et!

                int boyut=lsinirdeger.Items.Count;
                if ( boyut > 0)
                {
                    double sonsinir = (double)lsinirdeger.Items[boyut - 1];
                    double sonoran = (double)lvergiorani.Items[boyut - 1];

                    if (sinir <= sonsinir || oran <= sonoran)
                    {
                        MessageBox.Show("Girilen bilgiler listedeki değerlerden küçük veya eşit olamaz!");
                        return;
                    }
                }
   
                lsinirdeger.Items.Add(sinir);
                lvergiorani.Items.Add(oran);
                tsinirdeger.Clear();
                tvergiorani.Clear();
            }
        }

        private void bkapat_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void foranlar_FormClosing(object sender, FormClosingEventArgs e)
        {
            loran.Items.Clear();
            lsinir.Items.Clear();
            for (int index = 0; index < lsinirdeger.Items.Count; index++)
            {
                lsinir.Items.Add(lsinirdeger.Items[index]);
                loran.Items.Add(lvergiorani.Items[index]);
            }
        }
    }
}
